Attribute VB_Name = "modChooseColour"
'--
'Author: Sam Huggill
'Date: 15/5/99
'Time: 10:24 GMT
'ChooseColour module that shows the ChooseColour dialog
'and returns a long data value for the chosen colour
'--

Option Explicit

Private Type CHOOSECOLOR
  lStructSize As Long
  hwndOwner As Long
  hInstance As Long
  rgbResult As Long
  lpCustColors As String
  flags As Long
  lCustData As Long
  lpfnHook As Long
  lpTemplateName As String
End Type

Private Declare Function ShowColour Lib "comdlg32.dll" Alias "ChooseColorA" (pChoosecolor As CHOOSECOLOR) As Long

Function ChooseColour(hwnd As Long) As Long
    
    Dim CustomColours() As Byte
    ReDim CustomColours(0 To 15) As Byte
    Dim tChooseColour As CHOOSECOLOR
    
    '--
    'Show the ChooseColour dialog and return the colour
    '--

    With tChooseColour

        .hwndOwner = hwnd
        .lpCustColors = StrConv(CustomColours, vbUnicode)
        .lStructSize = Len(tChooseColour)

    End With

    If ShowColour(tChooseColour) = 0 Then Exit Function

    ChooseColour = tChooseColour.rgbResult

End Function
